import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Random;

/**
 * This class adds different objects to the world depending on the position of Link
 * 
 * @author Andrew Harmon
 * @version 5/12/2012
 */
public class Spawner extends Enemies
{

    /**
     * All variables for enemies that are spawned in the overworld and dungeon
     */
    private Object[] enemyPen;
    
    private int xCoords;
    private int yCoords;
    private int numOfEnemies;
    private String enemyName;
    
    private int timer;
    public static Boss B;
    public static Boss B2;
    public static Moblin m1;
    public static Moblin m2;
    public static Moblin m3;
    public static Moblin m4;
    public static Moblin m5;
    public static Moblin m6;
    public static Moblin m7;
    public static Moblin m8;
    public static Moblin m9;
    public static Moblin m10;
    public static Moblin m11;
    public static Moblin m12;
    public static Moblin m13;
    public static Moblin m14;
    public static Moblin m15;
    public static Moblin m16;
    public static Moblin m17;
    public static Moblin m18;
    public static Moblin m19;
    public static Moblin m20;
    
    public static Fireball f1;
    public static Fireball f2;
    public static Fireball f3;
    public static Fireball f4;
    public static Fireball f5;
    public static Fireball f6;
    public static Fireball f7;
    public static Fireball f8;
    public static Fireball f9;
    public static Fireball f10;
    public static Fireball f11;
    public static Fireball f12;
    public static Fireball f13;
    public static Fireball f14;
    public static Fireball f15;
    public static Fireball f16;
    public static Fireball f17;
    
    public static EndScreen endScreen = new EndScreen();
    
    public static boolean finish = false;
    
    /**
     * Act - do whatever the Spawner wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        spawnEnemies(UI.horizontalScreen, UI.verticalScreen);
    }    
    
    /**
     * Creates the enemies in the world
     */
    public Spawner()
    {
        timer = 1;
        
        Key.key8 = new Key(0, 0);
        m1 = new Moblin(0, 0);
        m2 = new Moblin(0, 0);
        m3 = new Moblin(0, 0);
        m4 = new Moblin(0, 0);
        m5 = new Moblin(0, 0);
        m6 = new Moblin(0, 0);
        m7 = new Moblin(0, 0);
        m8 = new Moblin(0, 0);
        m9 = new Moblin(0, 0);
        m10 = new Moblin(0, 0);
        m11 = new Moblin(0, 0);
        m12 = new Moblin(0, 0);
        m13 = new Moblin(0, 0);
        m14 = new Moblin(0, 0);
        m15 = new Moblin(0, 0);
        m16 = new Moblin(0, 0);
        m17 = new Moblin(0, 0);
        m18 = new Moblin(0, 0);
        m19 = new Moblin(0, 0);
        m20 = new Moblin(0, 0);
        B = new Boss(0,0);
        B2 = new Boss(0,0);
        f1 = new Fireball();
        f2 = new Fireball();
        f3 = new Fireball();
        f4 = new Fireball();
        f5 = new Fireball();
        f6 = new Fireball();
        f7 = new Fireball();
        f8 = new Fireball();
        f9 = new Fireball();
        f10 = new Fireball();
        f12 = new Fireball();
        f11 = new Fireball();
        f13 = new Fireball();
        f14 = new Fireball();
        f15 = new Fireball();
        f16 = new Fireball();
        f17 = new Fireball();
   
    }
    
    /**
     * Spawns the enemies on the screen at the X and Y coordinates indicated by the 
     * params
     * @param horiz
     *      X coordinate
     * @param vert
     *      Y coordinate
     */
    public void spawnEnemies(int horiz, int vert)
    {
        if(UI.dunVal==10)
        {
             if(B.isAlive() == false && B2.isAlive() == false){
                UI.music.stop();
                finish = true;
                //UI.endGame.play();
                //getWorld().addObject(endScreen, 126, 110);
                //Greenfoot.stop();
            }else{
             if(B.isAlive() == true)
                spawn(B, 80, 200);
                if(B.isAlive() == true)
                spawn(B2, 180, 200);
            }
        }
        
        if(horiz == 0 && vert == 1) { //screen 4
            if(m1.isAlive() == true)
                spawn(m1, 100, 140);
                
            if(m2.isAlive() == true)
                spawn(m2, 30, 110);
                
            if(m3.isAlive() == true)
                spawn(m3, 90, 120);
            
        } else if(horiz == 1 && vert == 0) { //screen 2
            if(m7.isAlive() == true)
                spawn(m7, 130, 150);
                
            if(m8.isAlive() == true)
                spawn(m8, 100, 140);
                
        } else if(horiz == 1 && vert == 1) { //screen 3
            if(m4.isAlive() == true)
                spawn(m4, 197, 200);
                
            if(m5.isAlive() == true)
                spawn(m5, 200, 120);
                
            if(m6.isAlive() == true)
                spawn(m6, 130, 160);
        }
 
    }

    /**
     * Determines how often the enemies are spawned by the spawner.
     */
    public void fireTime(){
        
        Random generator = new Random(); //random number generator
        int ranNum = generator.nextInt(15);
        
        if(ranNum==0)
        {
            Spawner.f1.alive=true; getWorld().addObject(Spawner.f1, 55, 90);
            Spawner.f1.resetShoot(1); Spawner.f1.stay=0;
        }
        else if(ranNum==1)
        {
            Spawner.f2.alive=true; getWorld().addObject(Spawner.f2, 65, 90);
            Spawner.f2.resetShoot(1); Spawner.f2.stay=0;
        }
        else if(ranNum==2)
        {
            Spawner.f3.alive=true; getWorld().addObject(Spawner.f3, 75, 90);
            Spawner.f3.resetShoot(1); Spawner.f3.stay=0;
        }
        else if(ranNum==3)
        {
            Spawner.f4.alive=true; getWorld().addObject(Spawner.f4, 85, 90);
            Spawner.f4.resetShoot(1); Spawner.f4.stay=0;
        }
        else if(ranNum==4)
        {
            Spawner.f5.alive=true; getWorld().addObject(Spawner.f5, 95, 90);
            Spawner.f5.resetShoot(1); Spawner.f5.stay=0;
        }
        else if(ranNum==5)
        {
            Spawner.f6.alive=true; getWorld().addObject(Spawner.f6, 105, 90);
            Spawner.f6.resetShoot(1); Spawner.f6.stay=0;
        }
        else if(ranNum==6)
        {
            Spawner.f7.alive=true; getWorld().addObject(Spawner.f7, 115, 90);
            Spawner.f7.resetShoot(1); Spawner.f7.stay=0;
        }
        else if(ranNum==7)
        {
            Spawner.f9.alive=true; getWorld().addObject(Spawner.f9, 125, 90);
            Spawner.f9.resetShoot(1); Spawner.f9.stay=0;
        }
        else if(ranNum==8)
        {
            Spawner.f10.alive=true; getWorld().addObject(Spawner.f10, 135, 90);
            Spawner.f10.resetShoot(1); Spawner.f10.stay=0;
        }
        else if(ranNum==9)
        {
            Spawner.f11.alive=true; getWorld().addObject(Spawner.f11, 145, 90);
            Spawner.f11.resetShoot(1); Spawner.f11.stay=0;
        }
        else if(ranNum==10)
        {
            Spawner.f12.alive=true; getWorld().addObject(Spawner.f12, 155, 90);
            Spawner.f12.resetShoot(1); Spawner.f12.stay=0;
        }
        else if(ranNum==11)
        {
            Spawner.f13.alive=true; getWorld().addObject(Spawner.f13, 165, 90);
            Spawner.f13.resetShoot(1); Spawner.f13.stay=0;
        }
        else if(ranNum==12)
        {
            Spawner.f14.alive=true; getWorld().addObject(Spawner.f14, 175, 90);
            Spawner.f14.resetShoot(1); Spawner.f14.stay=0;
        }
        else if(ranNum==13)
        {
            Spawner.f15.alive=true; getWorld().addObject(Spawner.f15, 185, 90);
            Spawner.f15.resetShoot(1); Spawner.f15.stay=0;
        }
        else if(ranNum==14)
        {
            Spawner.f16.alive=true; getWorld().addObject(Spawner.f16, 195, 90);
            Spawner.f16.resetShoot(1); Spawner.f16.stay=0;
        }
        else if(ranNum==15)
        {
            Spawner.f17.alive=true; getWorld().addObject(Spawner.f17, 205, 90);
            Spawner.f17.resetShoot(1); Spawner.f17.stay=0;
        }
        
        
    }
    
    /**
     * General class called to spawn Moblins
     */
    public  void spawn(Moblin x, int h, int w)
    {
        getWorld().addObject(x, h, w);
    }
    
    /**
     * General class called to spawn Octorocks
     */
    public  void spawn(Octorock x, int h, int w)
    {
        getWorld().addObject(x, h, w);
    }
    
    /**
     * General class called to spawn the Boss
     */
    public void spawn(Boss x, int h, int w)
    {
        getWorld().addObject(x, h, w);
    }
}
