import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * fireball from dungeon puzzle
 * 
 * @author Brendan McSherry
 * @version 5/10/2012
 */
public class Fireball extends UI
{
    /**
     * Declarations of all variables for the Fireball class
     */
    public static int stay=0;
    public static int animate=0;
    private static final int shootLength=100;
    private static int currShoot=shootLength;
    private int direction=0;
    private int imgRot=0;
    public boolean alive=true;
    private boolean finish=false;
    private boolean turn=false;
    
    /**
     * Act - do whatever the Projectile wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(stay==0){
        shoot();}
        else{Actor link = getOneIntersectingObject(Link.class);
            if(link != null){
                Link.linkIsHit();
                //getWorld().removeObject(this);
                finish=false;
                turn=false;
                //reset image back to original rotation angle
                turn(-imgRot);
                imgRot=0;
            }}
    }
    
    /**
     * Is called when the fireball is shot *NOT FULLY IMPLEMENTED*
     */
    public void shoot(){
        if(currShoot <= shootLength){
            if(direction == 0 && !turn){
                turn=true;
            }
            else if(direction ==1 && !turn){
                imgRot=90;
                turn(imgRot);
                turn=true;
            }
            else if(direction ==2 && !turn){
                imgRot = 180;
                turn(imgRot);
                turn=true;
            }
            else if(direction ==3 && !turn){
                imgRot=-90;
                turn(imgRot);
                turn=true;
            }
            //collision detection with Link
            Actor link = getOneIntersectingObject(Link.class);
            if(link != null){
                Link.linkIsHit();
                //getWorld().removeObject(this);
                finish=false;
                turn=false;
                //reset image back to original rotation angle
                turn(-imgRot);
                imgRot=0;
            }
            //collision with wall
           
            
            
            move(2);
            if(animate==0){
                setImage("fireball2.png");
                animate=1;}
                else{ setImage("fireball.png"); animate=0;}
            currShoot++;
        }
        else{
            
            finish=false;
            turn=false;
            //reset image back to original rotation angle
            turn(-imgRot);
            imgRot=0;
            getWorld().removeObject(this);
        }
    }
    
    /**
     * Removes the fireball from the world.
     */
     public void removeSelf()
    {
        this.getWorld().removeObject(this);
    }
    
    /**
     * Sets the alive boolean to false, and removes the fireball from the world.
     */
    protected void destroy()
    {
        alive = false;
        removeSelf();
    }
    
    /**
     * Returns a boolean based on whether the fireball is alive or not.
     */
    protected boolean isAlive()
    {
        return this.alive;
    }
    
    /**
     * Resets the shot of the fireball *NOT FULLY IMPLEMENTED*
     */
    public void resetShoot(int dir){
        if(currShoot < shootLength){ return;}
        if(!finish){
            direction = dir;
            finish=true;
        }
        currShoot=0;
    }
}
